"use strict";
var t = require('babel-types');
function babelPluginNativeAsyncForTypeScript() {
    return { visitor: visitor };
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = babelPluginNativeAsyncForTypeScript;
function last(array) {
    return array ? array[array.length - 1] : undefined;
}
function getParents(path, n) {
    if (n === void 0) { n = Infinity; }
    var parents = [];
    while (n--) {
        if (path) {
            path = path.parentPath;
            parents.push(path);
        }
        else {
            parents.push({});
        }
    }
    return parents;
}
var visitor;
(function (visitor) {
    var yieldToAwait;
    (function (yieldToAwait) {
        function YieldExpression(path) {
            var node = path.node;
            if (node.delegate)
                throw new Error('Cannot transform delegated yield expression to await');
            path.replaceWith(t.awaitExpression(node.argument));
        }
        yieldToAwait.YieldExpression = YieldExpression;
    })(yieldToAwait || (yieldToAwait = {}));
    function CallExpression(path) {
        var node = path.node;
        var parents = getParents(path, 4);
        var lastArgument = last(node.arguments);
        if (t.isIdentifier(node.callee, { name: '__awaiter' })
            && t.isThisExpression(node.arguments[0])
            && t.isFunction(lastArgument, { generator: true })
            && t.isReturnStatement(parents[0].node)
            && t.isBlockStatement(parents[1].node)
            && t.isFunction(parents[2].node)) {
            var node_1 = parents[2].node;
            var isDeclaration = t.isFunctionDeclaration(node_1);
            path.traverse(yieldToAwait);
            parents[2].replaceWith(isDeclaration
                ? t.functionDeclaration(node_1.id, node_1.params, lastArgument.body, false, true)
                : t.functionExpression(node_1.id, node_1.params, lastArgument.body, false, true));
        }
    }
    visitor.CallExpression = CallExpression;
})(visitor || (visitor = {}));
//# sourceMappingURL=index.js.map